package main

// Given a root node reference of a BST and a key, delete the node with the given key in the BST.
// Return the root node reference (possibly updated) of the BST.
//
// Basically, the deletion can be divided into two stages:
//
// Search for a node to remove.
// If the node is found, delete the node.

// Constraints:
//
// The number of nodes in the tree is in the range [0, 104].
// -105 <= Node.val <= 105
// Each node has a unique value.
// root is a valid binary search tree.
// -105 <= key <= 105

type TreeNode struct {
	Val   int
	Left  *TreeNode
	Right *TreeNode
}

func findMin(subTreeRoot *TreeNode) *TreeNode {
	for (subTreeRoot != nil) && (subTreeRoot.Left != nil) {
		subTreeRoot = subTreeRoot.Left
	}
	return subTreeRoot
}

func deleteNode(root *TreeNode, key int) *TreeNode {
	if root == nil {
		return nil
	}

	if key < root.Val {
		root.Left = deleteNode(root.Left, key)
	} else if key > root.Val {
		root.Right = deleteNode(root.Right, key)
	} else {
		if (root.Right == nil) && (root.Left == nil) {
			root = nil
			return root
		} else if (root.Right != nil) && (root.Left == nil) {
			root = root.Right
			return root
		} else if (root.Left != nil) && (root.Right == nil) {
			root = root.Left
			return root
		} else if (root.Left != nil) && (root.Right != nil) {
			minSubTreeNode := findMin(root.Right)
			deleteNode(root.Right, minSubTreeNode.Val)
			root.Val = minSubTreeNode.Val
			return root
		}
	}
	return root
}
