from typing import Optional
import pytest
# Definition for singly-linked list.


class ListNode:
    def __init__(self, val=0, next=None):
        self.val = val
        self.next = next

    def __repr__(self) -> str:
        return f"Val: {self.val}"


# Not solved by me
class Solution:
    def reverseList(self, head: Optional[ListNode]) -> Optional[ListNode]:
        rl = []
        if not head:
            return

        def rr(cn: ListNode):
            if cn.next:
                rr(cn.next)
                cn.next.next = cn
                rl.append(cn)
            else:
                rl.append(cn)

        rr(head)
        head.next = None

class SolutionFromLeetCode:
    def reverseList(self, head: ListNode) -> ListNode:
        # Initialize pointers
        prev = None  # Previous node starts as None
        curr = head  # Current node starts at the head

        # Traverse the list
        while curr is not None:
            next_node = curr.next  # Save the next node
            
            curr.next = prev  # Reverse the link
            
            # Move pointers forward
            prev = curr  # Move prev to the current node
            curr = next_node  # Move curr to the next node

        # prev is now the new head of the reversed list
        return prev


def test_solution():
    l5 = ListNode(val=5, next=None)
    l4 = ListNode(val=4, next=l5)
    l3 = ListNode(val=3, next=l4)
    l2 = ListNode(val=2, next=l3)
    l1 = ListNode(val=1, next=l2)
    sol = SolutionFromLeetCode()
    sol.reverseList(head=l1)
    assert l1.next is None
    assert l2.next == l1
    assert l3.next == l2
    assert l4.next == l3
    assert l5.next == l4


def test_solution_1():
    l2 = ListNode(val=2, next=None)
    l1 = ListNode(val=1, next=l2)
    sol = SolutionFromLeetCode()
    sol.reverseList(head=l1)
    assert l1.next is None
    assert l2.next == l1
