##################### Section ##############################
# Section topic: Arrays
#
# Design an algorithm to encode a list of strings to a single string. The encoded string is then decoded back to the original list of strings.
#
# Please implement encode and decode
#
# Example 1:
#
# Input: ["neet","code","love","you"]
#
# Output:["neet","code","love","you"]
# Example 2:
#
# Input: ["we","say",":","yes"]
#
# Output: ["we","say",":","yes"]
# Constraints:
#
# 0 <= strs.length < 100
# 0 <= strs[i].length < 200
# strs[i] contains only UTF-8 characters.
#
############################################################
from typing import List


class Solution:
    delim: str = "-+-"

    def encode(self, strs: List[str]) -> str:
        if not strs:
            return ""
        delim: str = self.delim
        res: str = ""
        counts: str = ""
        encoded: str = ""
        for elem in strs:
            counts += f"{len(elem)}{delim}"
            encoded += elem
        counts += delim
        res = counts + encoded
        return res

    def decode(self, s: str) -> List[str]:
        breakpoint()
        if not s:
            return []
        res = []
        splitted = s.split(f"{self.delim}{self.delim}")
        breaks = [int(s) for s in splitted[0].split(self.delim)]
        i = 0
        for l in breaks:
            res.append(splitted[1][i:i+l])
            i += l
        return res


s = Solution()

en = s.encode(strs=["we", "say", ":", "yes"])
en = s.encode(strs=["we", "", "say", ":", "yes"])
en = s.encode(strs=[])
print(s.decode(en))
